#include "priqueue.hh"

template <class Q, class T > Key<Q, T>::Key(Q& q,T& t)
{
  key    = q;
  value  = &t;
}

template <class Q, class T > Q Key<Q, T>::KeyValue()
{
  return key;
}

template <class Q, class T > T* Key<Q, T>::Value()
{
  return value;
}



template <class Q, class T > PriQueue<Q, T>::PriQueue()
{
  //PDEBUG2("Initializing a PriQueue at address: ",(void*)this);
  pFirst = NULL;
  pLast  = NULL;
  length = 0;
}

template <class Q, class T > PriQueue<Q, T>::~PriQueue()
{
  //PDEBUG2("Deleting a priqueue at address: ",(void*)this);

  Chain< Key<Q, T> >*  pChainNext = NULL;
  Chain< Key<Q, T> >*  pChainThis = this->pFirst;
  
  while(pChainThis != NULL)
    {
      pChainNext = pChainThis->GetNext();
      delete pChainThis;
      pChainThis = pChainNext;
    }
}

template <class Q, class T > int PriQueue<Q, T>::Length()
{
  return length;
}


template <class Q, class T> T* PriQueue<Q, T>::operator[](Q& key)
{
  Chain< Key<Q, T> >*  pChainThis = this->pFirst;

  while(pChainThis != NULL)
    {
      //cout << "priqueue: key = " << pChainThis->pData->KeyValue() << '\n'; 
      if(key == pChainThis->pData->KeyValue())
        return pChainThis->pData->Value();
      if(key < pChainThis->pData->KeyValue())
	break;
      else
	pChainThis = pChainThis->GetNext();
    }
  return NULL;
}


template <class Q, class T > void PriQueue<Q, T>::In(Q& key, T& TNew)
{
  Chain< Key<Q, T> >* pChainNew = new Chain< Key<Q, T> >();
  Chain< Key<Q, T> >* pChainTmp = pFirst;

  length++;

  pChainNew->pData = new Key<Q, T>(key,TNew);
  if(pFirst == NULL)
    {
      pFirst = pChainNew; 
      pLast = pChainNew;
    }
  else
    {
      while(pChainTmp != NULL)
	{
	  if(pChainTmp->pData->KeyValue() > key)
	    {
	      pChainTmp->AddBefore(pChainNew);
	      if(pChainTmp == pFirst)
		pFirst = pChainNew; 
	      break;
	    }
	  else
	    pChainTmp = pChainTmp->GetNext();
	}
      if(pChainTmp == NULL)
	{
	  pLast->AddAfter(pChainNew);
	  pLast = pChainNew;
	}
    }
}

template <class Q, class T > T* PriQueue<Q, T>::First()
{
  return pFirst->pData->Value();
}

template <class Q, class T > T* PriQueue<Q, T>::Out()
{
  Chain< Key<Q, T> >*  pChainTmp = pFirst;
  
  if(pChainTmp != NULL)  // >= 1
    {
      pFirst = pChainTmp->GetNext();
      if(pFirst != NULL) // >=2
	pFirst->RemBefore();
      else               // == 1
	pLast == NULL;
      
      length--;
      return pChainTmp->pData->Value();
    }
  else
    return NULL;
}















